﻿/*
Création  : 16/03/2013
Révision : 25/01/2017
----------------------------------------------------------------------------------
IDE : Visual Studio Code
----------------------------------------------------------------------------------
Projet : Domotique (Animation du déplacement d'un volet roulant)
Version : 2
Fichier : voletV2.js
--------------------------------------------------------------------------------
Commentaires : La position du volet change en fonction de la valeur
lue dans un fichier xml (quatre positions)
Solution avec un graphe d'états pour plus de réalisme.
--------------------------------------------------------------------------------
Remarque : Le script doit être exécuté sur un serveur Apache 
--------------------------------------------------------------------------------
*/

// Variables globales
var etat = 0;

$(document).ready(function () {
	var FREQ = 2500; // Lecture périodique. Changement d'état du volet toutes les 2*FREQ

	// Appel de la fonction de lecture de la position du volet dans un fichier xml	
	function startAJAXcalls() {
		setTimeout(function () {
			getXMLPosVolet();
			startAJAXcalls();
		},
			FREQ
		);
	}

	startAJAXcalls(); // Appel pour démarer la fonction

	// Lecture de la valeur de la position du volet dans un fichier xml	
	function getXMLPosVolet() {
		$.ajax({
			url: "data/data.xml",
			cache: false,
			dataType: "xml",
			success: function (xml) {
				$(xml).find("donnee").each(function () {
					var $position = $(this).find("posvolet").text();
					//alert ("Posit: " + $position + " et etat " + etat ); // Visualisation de la variable pour le test

					switch (etat) {
						case 0: $("#volet25").hide();
							if ($position == 1) { etat = 1; } else { etat = 0; }
							break;
						case 1: $("#volet25").show();
							if ($position == 2) { etat = 2; }
							else if ($position == 0) { etat = 0; }
							else { etat = 1; }
							break;
						case 2: $("#volet50").show();
							if ($position == 3) { etat = 3; }
							else if ($position == 1) { etat = 7; }
							else { etat = 2; }
							break;
						case 3: $("#volet75").show();
							if ($position == 4) { etat = 4; }
							else if ($position == 2) { etat = 6; }
							else { etat = 3; }
							break;
						case 4: $("#volet100").show();
							if ($position == 3) { etat = 5; } else { etat = 4; }
							break;
						case 5: $("#volet100").hide();
							if ($position == 2) { etat = 6; }
							else if ($position == 4) { etat = 4; }
							else { this.etat = 5; }
							break;
						case 6: $("#volet75").hide();
							if ($position == 1) { etat = 7; }
							else if ($position == 3) { etat = 3; }
							else { etat = 6; }
							break;
						case 7: $("#volet50").hide();
							if ($position == 0) { etat = 0; }
							else if ($position == 2) { etat = 2; }
							else { etat = 7; }
							break;
						default: { } break;
					}
				});
			}
		});
	}
});